/* filtermodule.h
 * Copyright (C) 2001 The University of Newcastle upon Tyne
 *
 * Written by Paul Coates (Paul.Coates@ncl.ac.uk)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#ifndef FILTER_MODULE_H
#define FILTER_MODULE_H 1

#include "filter.h"

class FilterItem;
class FilterModule
{
	public:
		FilterModule(GtkWidget *w);
		~FilterModule();

		void create();
		void select(int r);
		void unselect();
		void up();
		void down();
		void permit();
		void deny();
		void del();
		void add();
		void copytowidgets(Filter *f);
		void copyfromwidgets(Filter *f);
		int match(IPAddress ip);

		int row;
		GtkWidget *window;
		GtkWidget *vbox58;
		GtkWidget *hbox77;
		GtkWidget *label147;
		GSList *hbox77_group;
		GtkWidget *radiobutton13;
		GtkWidget *radiobutton14;
		GtkWidget *hbox78;
		GtkWidget *scrolledwindow28;
		GtkWidget *clist25;
		GtkWidget *label149;
		GtkWidget *label150;
		GtkWidget *label151;
		GtkWidget *vbox55;
		GtkWidget *button72;
		GtkWidget *pixmap14;
		GtkWidget *button73;
		GtkWidget *pixmap15;
		GtkWidget *button74;
		GtkWidget *button75;
		GtkWidget *button76;
		GtkWidget *button77;
		GtkWidget *button78;
		GtkWidget *hbox79;
		GtkWidget *entry34;
		GtkWidget *button79;
};

#endif

