/* graph.h
 * Copyright (C) 2002 The University of Newcastle upon Tyne
 *
 * Written by Paul Coates (Paul.Coates@ncl.ac.uk)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#ifndef GRAPH_H
#define GRAPH_H 1

#include <gtk/gtk.h>

#define TOP_MGN 8
#define LEFT_MGN 56
#define RIGHT_MGN 4
#define BOTTOM_MGN 28

class Main;
class DataSet;
class Graph
{
	public:
		Graph(Main *m);
		~Graph();

		Main *main;
		gint width, height;		// size of drawing area used to check for resize
		GdkPixmap *canvas;		// canvas used to double buffer graphics
		int scale;						// linear / log
		DataSet *data;				// the data to be drawn in the graph
		char *check_states;		// used to record state of checkboxes to show lines

		void draw();
		void draw_line(int var);
};

#endif

