/* graph.cc
 * Copyright (C) 2001 The University of Newcastle upon Tyne
 *
 * Written by Paul Coates (Paul.Coates@ncl.ac.uk)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#include <string.h>
#include "dataset.h"

DataSet::DataSet()
{
	variables = NULL;
	status = NULL;
	timestamps = NULL;
	num_variables = 0;
	num_entries = 0;
}

DataSet::~DataSet()
{
	empty();
}

void DataSet::empty()
{
	if (variables != NULL) delete [] variables;
	if (timestamps!=NULL) delete [] timestamps;
	if (status!=NULL) delete [] status;
	variables = NULL;
	status = NULL;
	timestamps = NULL;
	num_variables = 0;
	num_entries = 0;
}

DataLine::DataLine()
{
	values = NULL;
}

DataLine::~DataLine()
{
	empty();
}

void DataLine::empty()
{
	if (values != NULL)
		delete [] values;
	values = NULL;
}

void DataSet::print()
{
	int i, j;

	printf("DATASET (%d variables, %d entries\n",
		num_variables, num_entries);
	for (i=0; i<num_entries; i++)
	{
		if (i<20)
		{
			printf("Entry %d, Timestamp %s\n", i, timestamps[i].date_to_str(1));
			for (j=0; j<num_variables; j++)
			{
				printf(" %lu\n", variables[j].values[i]);
			}
			printf("end\n");
		}
	}
}

