#include <string.h>
#include <stdio.h>
#include "macaddress.h"

MACAddress::MACAddress()
{
	empty();
}

MACAddress::~MACAddress()
{
}

MACAddress::MACAddress(MACAddress &orig)
{
	int i;
	for (i=0; i<6; i++) mac[i] = orig.mac[i];
}

void MACAddress::operator = (const MACAddress &orig)
{
	int i;
	for (i=0; i<6; i++) mac[i] = orig.mac[i];
}

void MACAddress::empty()
{
	int i;
	for (i=0; i<6; i++) mac[i] = 0;
}

// format is "aa bb cc dd ee ff "
void MACAddress::setstringsnmp(char *str)
{
	int i, v[6];
	char buf[4];

	if (strlen(str)!=20) return;
	empty();
	for (i=0; i<6; i++)
	{
		buf[0] = str[(i*3)+1]; buf[1] = str[(i*3)+2]; buf[2] = '\0';
		if (sscanf(buf, "%x", &v[i])!=1) return;
	}
	for (i=0; i<6; i++) mac[i] = v[i];
}

// format is %d.%d.%d.%d.%d.%d
void MACAddress::setstringsnmp2(char *str)
{
	int i, v[6];

	empty();

	if (sscanf(str, "%d.%d.%d.%d.%d.%d", &v[0], &v[1], &v[2], &v[3], &v[4], &v[5])!=6) return;
	for (i=0; i<6; i++) mac[i] = v[i];
}

void MACAddress::setstring(char *str)
{
	int i, v[6];
	char buf[4];

	if (strlen(str)!=12) return;
	empty();
	for (i=0; i<6; i++)
	{
		buf[0] = str[i*2]; buf[1] = str[(i*2)+1]; buf[2] = '\0';
		if (sscanf(buf, "%x", &v[i])!=1) return;
	}
	for (i=0; i<6; i++) mac[i] = v[i];
}

void MACAddress::setstringdelim(char *str)
{
	int i, v[6];
	char buf[4];

	if (strlen(str)!=12) return;
	empty();
	for (i=0; i<6; i++)
	{
		buf[0] = str[i*3]; buf[1] = str[(i*3)+1]; buf[2] = '\0';
		if (sscanf(buf, "%x", &v[i])!=1) return;
	}
	for (i=0; i<6; i++) mac[i] = v[i];
}

void MACAddress::set(MACAddress pm)
{
	int i;
	for (i=0; i<6; i++) mac[i] = pm.mac[i];
}

char *MACAddress::getstring()
{
	static char buf[16];
	sprintf(buf, "%02x%02x%02x%02x%02x%02x",
		mac[0], mac[1], mac[2], mac[3], mac[4], mac[5]);
	return buf;
}

char *MACAddress::getstring(char delim)
{
	static char buf[16];
	sprintf(buf, "%02x%c%02x%c%02x%c%02x%c%02x%c%02x", mac[0], delim,
		mac[1], delim, mac[2], delim, mac[3], delim, mac[4], delim, mac[5]);
	return buf;
}

void MACAddress::print()
{
	printf("%02x%02x%02x%02x%02x%02x",
		mac[0], mac[1], mac[2], mac[3], mac[4], mac[5]);
}

int MACAddress::compare(MACAddress mac2)
{
	int i, flag=1;
	for (i=0; i<6; i++)
		if (mac[i] != mac2.mac[i]) flag=0;
	return flag;
}

int MACAddress::zero()
{
	int i, flag=1;
	for (i=0; i<6; i++)
		if (mac[i] != 0) flag=0;
	return flag;
}

