#ifndef MISC_H
#define MISC_H 1

#include <time.h>
#include <glib.h>
#include "header.h"

#define MAILCMD "/usr/lib/sendmail -bs >/dev/null"
#define SENDER  "Nomad Network Monitor"

int contains(char *str, char *substr);
int lower_contains(char *str, char *substr);
int starts_with(char *str, char *bigstr);
void write_int32(FILE *f, int val);
void write_ulong32(FILE *f, unsigned long val);
int read_int32(FILE *f);
unsigned long read_ulong32(FILE *f);
void write_int64(FILE *f, int val);
void write_ulong64(FILE *f, unsigned long val);
int read_int64(FILE *f);
unsigned long read_ulong64(FILE *f);
int send_email(char *address, char *subject, char *message);
char *user_file(char *fname);
gint32 timestr_to_int(gchar *str);
gchar *int_to_timestr(gint32 num);
int linesInFile(char *fname);
gboolean validFilename(gchar *str);

DeviceType stringToDeviceType(gchar *str);
gchar *deviceTypeToString(DeviceType subtype);
DeviceGroupType stringToDeviceGroupType(gchar *str);
gchar *deviceGroupTypeToString(DeviceGroupType subtype);
NetworkType stringToNetworkType(gchar *str);
gchar *networkTypeToString(NetworkType subtype);
NetworkPositionType stringToNetworkPositionType(gchar *str);
gchar *networkPositionTypeToString(NetworkPositionType position);
NetworkGroupType stringToNetworkGroupType(gchar *str);
gchar *networkGroupTypeToString(NetworkGroupType group);

#endif

