#include <stdlib.h>
#include <string.h>
#include "timeframe.h"

TimeFrame::TimeFrame()
{
	empty();
}

TimeFrame::~TimeFrame()
{
}

void TimeFrame::empty()
{
	strcpy(descr, "Unknown");
	start = 540;
	end = 1020;
	daymask = 31;
	inverse_flag = '0';
}

void TimeFrame::save(xmlNodePtr xmlnode)
{
	xmlNodePtr newxml;
	char buf[32];

	newxml = xmlNewChild(xmlnode, NULL, (xmlChar*)"TimeFrame", NULL);
	xmlSetProp(newxml, (xmlChar*)"descr", (xmlChar*)descr);
	sprintf(buf, "%d", start);
	xmlSetProp(newxml, (xmlChar*)"start", (xmlChar*)buf);
	sprintf(buf, "%d", end);
	xmlSetProp(newxml, (xmlChar*)"end", (xmlChar*)buf);
	sprintf(buf, "%d", daymask);
	xmlSetProp(newxml, (xmlChar*)"mask", (xmlChar*)buf);
	sprintf(buf, "%c", inverse_flag);
	xmlSetProp(newxml, (xmlChar*)"inverse", (xmlChar*)buf);
}

void TimeFrame::load(xmlNodePtr xmlnode)
{
	xmlChar *buf;

	if (!xmlnode || !xmlnode->name || strcmp((char*)xmlnode->name, "TimeFrame")!=0)
		return;
	empty();
	buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"descr");
	if (buf!=NULL) { strcpy(descr, (char*)buf); free(buf); }
	buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"start");
	if (buf!=NULL) { sscanf((char*)buf, "%d", &start); free(buf); }
	buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"end");
	if (buf!=NULL) { sscanf((char*)buf, "%d", &end); free(buf); }
	buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"mask");
	if (buf!=NULL) { sscanf((char*)buf, "%d", &daymask); free(buf); }
	buf = (xmlChar*)xmlGetProp(xmlnode, (xmlChar*)"inverse");
	if (buf!=NULL) { inverse_flag = buf[0]; free(buf); }
}

